# %%
import pandas as pd 
from pathlib import Path 
import numpy as np 
import matplotlib.pyplot as plt
import matplotlib as mpl
# %%
dataNQ_N190 = pd.read_excel('220209_N190_results.xlsx', sheet_name='Nq_data', engine='openpyxl', skiprows=range(3))

fitNQ_N190 = pd.read_excel('220209_N190_results.xlsx', sheet_name='Nq_fit', engine='openpyxl', skiprows=range(3))

dataBode_N190 = pd.read_excel('220209_N190_results.xlsx', sheet_name='Bode_data', engine='openpyxl', skiprows=range(3))

fitBode_N190 = pd.read_excel('220209_N190_results.xlsx', sheet_name='Bode_fit', engine='openpyxl', skiprows=range(3))


###########
dataNQ_N172 = pd.read_excel('220209_N172_results.xlsx', sheet_name='Nq_data', engine='openpyxl', skiprows=range(3))

fitNQ_N172 = pd.read_excel('220209_N172_results.xlsx', sheet_name='Nq_fit', engine='openpyxl', skiprows=range(3))

dataBode_N172 = pd.read_excel('220209_N172_results.xlsx', sheet_name='Bode_data', engine='openpyxl', skiprows=range(3))

fitBode_N172 = pd.read_excel('220209_N172_results.xlsx', sheet_name='Bode_fit', engine='openpyxl', skiprows=range(3))

# %%
cm = 1/2.54
w = 6.5*cm
fig, (ax1) = plt.subplots(figsize=(w, w/1.25))

font1 = 12
font2 = 10
mpl.rc('xtick', labelsize=font2)
mpl.rc('ytick', labelsize=font2)
majortik = 4
minortik = 2
width = 1

plt.rcParams['axes.linewidth'] = 1
plt.rcParams['font.family'] = 'sans-serif'
plt.rcParams['font.sans-serif'] = ['Arial']
linewidth = 1
markersize = 2

#ax1.set_xlabel(r'$ \rm C_{ch} \ / \ C_{loaded}$', labelpad=10, fontsize = font1)
#ax1.set_ylabel(r'$ \rm C_{dc} \ / \ C_{loaded}$', labelpad=10, fontsize = font1)

ax1.set_xlabel(r'$\rm Z^{\prime} (\omega) [m\Omega]$', labelpad=10, fontsize = font1)
ax1.set_ylabel(r'$\rm -Z^{\prime \prime} (\omega) [m\Omega] $', labelpad=10, fontsize = font1)
############### Plots ##################
label = ['3D Mesh', 'Non-3D']

ax1.plot(dataNQ_N190['Zre'].multiply(1000), dataNQ_N190['Zim'].multiply(-1000), marker = 'o', color = 'b', linestyle = 'None', markersize = markersize, label = label[0], markevery = 2)
ax1.plot(fitNQ_N190['Zre'].multiply(1000), fitNQ_N190['Zim'].multiply(-1000), color = 'b', linewidth = linewidth, markersize = markersize)

ax1.plot(dataNQ_N172['Zre'].multiply(1000), dataNQ_N172['Zim'].multiply(-1000), marker = 's', color = 'k', linestyle = 'None', markersize = markersize, label = label[1], markevery = 2)
ax1.plot(fitNQ_N172['Zre'].multiply(1000), fitNQ_N172['Zim'].multiply(-1000), color = 'k', linewidth = linewidth, markersize = markersize)

ax1.legend(frameon=False,loc='upper left', fontsize = font2)

ax1.set_ylim([0, 33])
ax1.set_xlim([0, 65])

xtick = [20, 10]  # major, minor
ytick = [10, 5]  # major, minor

ax1.xaxis.set_tick_params(which='major', size=majortik, width=width, direction='out', top = False)
ax1.yaxis.set_tick_params(which='major', size=majortik, width=width, direction='out', right = False)
ax1.xaxis.set_tick_params(which='minor', size=minortik, width=width, direction='out', top = False)
ax1.yaxis.set_tick_params(which='minor', size=minortik, width=width, direction='out', right = False)


ax1.xaxis.set_major_locator(mpl.ticker.MultipleLocator(xtick[0]))
ax1.xaxis.set_minor_locator(mpl.ticker.MultipleLocator(xtick[1]))
ax1.yaxis.set_major_locator(mpl.ticker.MultipleLocator(ytick[0]))
ax1.yaxis.set_minor_locator(mpl.ticker.MultipleLocator(ytick[1]))

filename = 'EIS_Ch_OC_N190N172_pdf'
format = 'pdf'
#plt.savefig('Figures/'+ filename +'.' + format, dpi=600, transparent=False, bbox_inches='tight', format = format)
#pdftoppm -png -r 330 EIS_Ch_OC_N190N172_pdf.pdf EIS_Ch_OC_N190N172_png_word 
# %%

# Next: determine Cdl from CPE values semi-circle
# Brug et al. (from Kakaei et al. ): equation to determine Ceff 

def Ceff(Q0, alpha, Rs, Rp): 
    
    Cdl = (Q0*(1/Rs+1/Rp)**(1-alpha))**(1/alpha)
    
    return Cdl

# equation from McCroty et al. 

def Ceff2(Q0, alpha, Rp): 
    
    Cdl = (Q0*Rp)**(1/alpha)/Rp
    
    return Cdl



# %%

# circuit: 
Q0_N172 = 1.014
alpha_N172 = 0.78678
Rs_N172 = 0.011995
Rp_N172 = 0.01456

Q0_N190 = 2.452
alpha_N190 = 0.79849
Rs_N190 = 0.0089009
Rp_N190 = 0.011099

Cdl_N190 = Ceff(Q0_N190, alpha_N190, Rs_N190, Rp_N190)
Cdl_N172 = Ceff(Q0_N172, alpha_N172, Rs_N172, Rp_N172)

#%% 
############ using the equation from McCrory ###

Cdl_N190_2= Ceff2(Q0_N190, alpha_N190, Rp_N190)
Cdl_N172_2 = Ceff2(Q0_N172, alpha_N172, Rp_N172)
# much higher value mesh electrode ..... does not make sense
# compare with other circuits 
# %%
# save to excel 
data = {'Zre':dataBode_N190['Zre'].multiply(1000), 'Zim':dataBode_N190['Zim'].multiply(-1000)}
df = pd.DataFrame(data)
df.to_excel('S13_3D_exp.xlsx', index=False)
# %% 
